menu menubar,nicklist,channel,query {
  Tmax Reference Tools v11-A
  .Dictionary:dict
  .Conversion tool:conv
}
dialog dictionary {
  title "Webster's English Dictionary v1.0"
  size -1 -1 314 188
  edit "", 3, 131 160 118 20, autohs
  button define, 4, 253 159 50 20
  edit "", 6, 10 34 295 119, read multi return vsbar
  box "", 7, 4 0 306 30
  text "", 8, 15 11 290 16
  button clear, 10, 68 159 50 20, disable
  button close, 17, 12 159 50 20, ok
}
on *:dialog:dictionary:edit:*:{
  if ($did == 3) {
    if ($chr(32) isin $did(dictionary,3)) || ($chr(44) isin $did(dictionary,3)) did -ra dictionary 3 $remove($did(dictionary,3),$chr(32),$chr(44))
    did $iif($did(dictionary,3),-e,-b) dictionary 4
  }
}
on *:dialog:dictionary:sclick:*:{
  if ($did == 17) { if ($sock(dictionary).mark) sockclose dictionary }
  if ($did == 4) { did -b dictionary 3,4 | did -r dictionary 6,8 | define $did(dictionary,3) }
  if ($did == 10) { did -r dictionary 6,8 }
}
alias -l define sockopen dictionary dict.org 2628 | sockmark dictionary $1 | did -o dictionary 8 1 connecting...
alias dict {
  if ($dialog(dictionary) == $null) { dialog -m dictionary dictionary | if ($1) { did -ra dictionary 3 $1 | did -r dictionary 6 | did -b dictionary 3,4 | define $1 } }
}
on *:sockopen:dictionary:sockwrite -nt dictionary define web1913 $sock($sockname).mark
on *:sockread:dictionary:{
  sockread %di
  if (552 isin %di) { did -o dictionary 8 1 no match for ' $+ $sock(dictionary).mark $+ ' | unset %diict | sockclose $sockname | did -e dictionary 3,4 | halt }
  if (250 isin %di) { unset %diict | sockclose $sockname | did -e dictionary 3,4 | did -o dictionary 8 1 $chr(34) $+ $did(dictionary,3).text $+ $chr(34) successfully defined | halt }
  if (151 isin %di) { set %diict yes }
  if (%diict) did -a dictionary 6 $remove($replace(%di,151,***),auth.mime) $crlf
  unset %di
  did -e dictionary 10
}
on *:sockclose:dictionary:did -e dictionary 3,4
alias weather {
  if ($1 != $null) { %get.weather.zip = $1- } 
  if ($_vr(weather,trigger) == $null) { _vw weather trigger !weather }
  sockopen weather www.wunderground.com 80
  if ($active == $chan) { %get.wet.chan = $active }
  if (%get.wet.nick == $null) { %get.wet.nick = $me } 
}
on *:sockopen:weather:{
  if ($dialog(weather) != $null) { if ($sockerr > 0) { $d(-ra) 1 error: transfer data. unable to connect. | return } }
  sockwrite -tn $sockname GET /cgi-bin/findweather/getForecast?query= $+ $replace(%get.weather.zip,$chr(32),$chr(43))
  sockwrite -tn $sockname Host: www.wunderground.com  
  sockwrite -tn $sockname Connection: Keep-Alive 
  sockwrite -tn $sockname $crlf
  window -nh @weather
}

alias conv { dialog -mrv convtool convtool }
dialog convtool {
  title "Tmax Conversion Tool"
  option dbu
  size -1 -1 98 116
  edit "", 1, 47 54 48 10
  button "copy", 9, 29 102 37 10
  button "convert", 6, 30 66 37 10
  edit "", 4, 4 86 89 10, read autohs
  combo 5, 2 3 92 49, size
  text "input numeric(s):", 7, 4 55 42 8
  box "conversion:", 8, 2 78 94 21
}
alias convtool {
  if ($_vr(convtool,t)  == fc) { did -ra convtool 4 $did(convtool,1).text farenheit > $calc(($did(convtool,1).text - 32) / 1.8) celsius }
  elseif ($_vr(convtool,t) == cf) { did -ra convtool 4 $did(convtool,1).text celsius > $calc(($did(convtool,1).text * 1.8) + 32) farenheit }
  elseif ($_vr(convtool,t) == mf) { did -ra convtool 4 $did(convtool,1).text meters > $calc($did(convtool,1).text * 3.28084) feet }
  elseif ($_vr(convtool,t) == fm) { did -ra convtool 4 $did(convtool,1).text feet > $calc($did(convtool,1).text / 3.28084) meters }
  elseif ($_vr(convtool,t) == ci) { did -ra convtool 4 $did(convtool,1).text centimeters > $calc($did(convtool,1).text * 0.3937) inches }
  elseif ($_vr(convtool,t) == ic) { did -ra convtool 4 $did(convtool,1).text inches > $calc($did(convtool,1).text / 0.3937) centimeters }
  elseif ($_vr(convtool,t) == kp) { did -ra convtool 4 $did(convtool,1).text kilos > $calc($did(convtool,1).text * 2.20462) pounds }
  elseif ($_vr(convtool,t) == pk) { did -ra convtool 4 $did(convtool,1).text pounds > $calc($did(convtool,1).text / 2.20462) kilos }
  elseif ($_vr(convtool,t) == mkm) { did -ra convtool 4 $did(convtool,1).text miles > $calc($did(convtool,1).text / 0.62137) kilometers }
  elseif ($_vr(convtool,t) == kmm) { did -ra convtool 4 $did(convtool,1).text kilometers > $calc($did(convtool,1).text * 0.62137) miles }
}
on *:dialog:convtool:init:*: {
  did -a convtool 5 kilometers > miles
  did -a convtool 5 miles > kilometers
  did -a convtool 5 farenheit > celsius
  did -a convtool 5 celsius > farenheit
  did -a convtool 5 kilos > pounds
  did -a convtool 5 pounds > kilos
  did -a convtool 5 meters > feet
  did -a convtool 5 feet > meters
  did -a convtool 5 centimeters > inches
  did -a convtool 5 inches > centimeters
}
on *:dialog:convtool:sclick:*:{
  if ($did == 9) { clipboard $did(convtool,4) }
  if ($did == 6) { 
    if ($did(convtool,1) !isnum) { did -ra convtool 4 Invalid characters or value. | return }
    elseif ($did(convtool,5,1).seltext == kilometers > miles) { _vw convtool t kmm }
    elseif ($did(convtool,5,2).seltext == miles > kilometers) { _vw convtool t mkm }
    elseif ($did(convtool,5,3).seltext == farenheit > celsius) { _vw convtool t fc }
    elseif ($did(convtool,5,4).seltext == celsius > farenheit) { _vw convtool t cf }
    elseif ($did(convtool,5,5).seltext == kilos > pounds) { _vw convtool t kp }
    elseif ($did(convtool,5,6).seltext == pounds > kilos) { _vw convtool t pk }
    elseif ($did(convtool,5,7).seltext == meters > feet) { _vw convtool t mf }
    elseif ($did(convtool,5,8).seltext == feet > meters) { _vw convtool t fm }
    elseif ($did(convtool,5,9).seltext == centimeters > inches) { _vw convtool t ci }
    elseif ($did(convtool,5,10).seltext == inches > centimeters) { _vw convtool t ic }
    convtool
  }
}
}
