alias sb5 {
  if ($dialog(setup) == $null) { 
    dialog -m setup setup | sclick 
  }
}
dialog setup {
  title "Tmax Digital Setup"
  size -1 -1 352 320
  button "OK", 1, 295 30 40 20, ok
  box "Personal Info", 2, 1 1 280 119
  text "Gender", 3, 10 20 50 12
  combo 4, 60 18 75 100, drop
  text "City:", 5, 140 20 50 12
  text "State:", 6, 140 45 50 12
  text "Country:", 7, 140 70 50 12
  text "Age:", 8, 10 45 50 12
  text "Info:", 9, 10 70 50 12
  text "ICQ UIN:", 30, 10 95 50 12
  edit "", 31, 60 93 75 20
  text "Time zone", 32, 140 95 50 12
  edit "", 33, 200 93 75 20
  edit "", 10, 60 43 75 20
  edit "", 11, 60 68 75 20, autohs
  edit "", 12, 200 18 75 20, autohs
  edit "", 13, 200 43 75 20, autohs
  edit "", 14, 200 68 75 20, autohs
  box "Extended Color", 15, 1 130 350 90
  check "Extended Color", 16, 10 145 100 20
  button "Use default color", 17, 120 143 100 20
  button "Setup color", 18, 230 143 100 20
  check "Tmax Background Graphics", 19, 10 170 200 20
  check "Startup Random Midi", 28, 10 195 150 20
  box "Modes", 34, 10 220 102 75
  check "Invisible", 35, 15 231 100 20
  check "Wallops", 36, 15 251 100 20
  check "Server Notices", 37, 15 271 100 20
  button "Setup color", 38, 230 143 100 20
  button "Setup Autojoin", 40, 120 240 90 20
  button "F-key Join Setup", 41, 120 270 90 20
  check "Op  Console", 43, 240 175 150 20
  check "System Sounds", 42, 240 195 150 20
}
alias -l shgui {
  if ($$1 == -v) did -h setup 15
  else did -v setup 15
}
on *:dialog:setup:init:*: {
  shgui -h
  if ($_vr(setup,sound) == $null) { _vw setup sound on } 
  if ($_vr(opcon,switch) == $null) { _vw opcon switch on } 
  if ($_vr(info,age) == $null) { _vw info age <age not set> } 
  if ($_vr(info,tzone) == $null) { _vw info tzone <time zone not set> } 
  if ($_vr(info,other.info) == $null) { _vw info other.info <not set> } 
  if ($_vr(info,city) == $null) { _vw info city <city not set> } 
  if ($_vr(info,icq) == $null) { _vw info icq <icq uin not set> } 
  if ($_vr(info,state) == $null) { _vw info state <state not set> } 
  if ($_vr(info,country) == $null) { _vw info country <country not set> } 
  if ($_vr(color,color_switch) == off) { did -b setup 17,18 }  
  did -a setup 4 male
  did -a setup 4 female
  if ($_vr(color,color_switch) == on) { did -c setup 16 }
  if ($_vr(info,age) != $null) did -a setup 10 $_vr(info,age)
  if ($_vr(info,other.info) != $null) { did -a setup 11 $_vr(info,other.info) }
  if ($_vr(info,city)1 != $null) { did -a setup 12 $_vr(info,city) }
  if ($_vr(info,icq) != $null) { did -a setup 31 $_vr(info,icq) }
  if ($_vr(info,state) != $null) { did -a setup 13 $_vr(info,state) }
  if ($_vr(info,country) != $null) { did -a setup 14 $_vr(info,country) }
  if ($_vr(info,tzone) != $null) { did -a setup 33 $_vr(info,tzone) }
  if ($_vr(info,gender) != $null) {
    if ($_vr(setup,backpics) == $null) { _vw setup backpics on | graf.on }  
    if ($_vr(info,gender) == male) did -c setup 4 1
    else did -c setup 4 2
  }
  else {
    _vw info gender male
    genderset
    did -c setup 4 1
  }
  if ($_vr(setup,sound) == on) { did -c setup 42 } 
  if ($_vr(setup,backpics) == on) { did -c setup 19 }
  if ($_vr(setup,midi) == on) { did -c setup 28 }
  ;  if ($did(setup,20).state == 1) { shgui -v }
  if ($_vr(modes,invisible) == [on]) { did -c setup 35 }
  if ($_vr(modes,wallops) == [on]) { did -c setup 36 }
  if ($_vr(modes,snotice) == [on]) { did -c setup 37 }
  ;  if (%toolbar == [on]) { did -c setup 38 }
}
on *:dialog:setup:edit:*: {
  if ($did == 33) { 
    if ($did(setup,33).text == $null) { _vw info tzone <time zone not set> }
    else _vw info tzone $did(setup,33).text 
  } 
  if ($did == 10) { 
    if ($did(setup,10).text == $null) { _vw info age <age not set> }
    _vw info age $did(setup,10).text 
  }
  if ($did == 11) { 
    if ($did(setup,11).text == $null) { _vw info other.info <info not set> }
    _vw info other.info $did(setup,11).text
  } 
  if ($did == 12) { 
    if ($did(setup,12).text == $null) { _vw info city <city not set> }
    _vw info city $did(setup,12).text 
  }
  if ($did == 13) { 
    if ($did(setup,13).text == $null) { _vw info state <state not set> }
    _vw info state $did(setup,13).text
  }
  if ($did == 14) { 
    if ($did(setup,14).text == $null) { _vw info country <country not set> }
    _vw info country $did(setup,14).text
  }
  if ($did == 31) { 
    if ($did(setup,31).text == $null) { _vw info icq <icq uin not set> }
    _vw info icq $did(setup,31).text 
  }
}
on *:dialog:setup:sclick:*: {
  if ($did == 19) {
    if ($_vr(setup,backpics) == off) { 
      _vw setup backpics on | did -c setup 19 
      set %b graphics\default\ 
      graf.on
    }
    else { 
      _vw setup backpics off | did -u setup 19
      set %b graphics\default\ 
      graf.off
    }
  }
  if ($did == 20) {
    if ($did(setup,20).state == 1) { shgui -v | sclick }
    else { shgui -h | sclick }
  }
  if ($did == 16) {
    if ($_vr(color,color_switch) != on) { _vw color color_switch on | did -e setup 17,18 | .enable #extended.color | set %nick.disp1 [on] | set.col.on | sclick }
    else { unset %exstamp1 | unset %exstamp2 | did -b setup 17,18 | _vw color color_switch off | .disable #extended.color | sclick }
  }
  if ($did == 17) { set.col.on | sclick }
  if ($did == 18) { .timer -m 1 1 sb1 | sclick | halt }
  if ($did == 1) {
    if ($did(setup,28).state == 0) { _vw setup midi off }
    if ($did(setup,35).state == 0) { _vw modes invisible [off] }
    if ($did(setup,36).state == 0) { _vw modes wallops [off] }
    if ($did(setup,37).state == 0) { _vw modes snotice [off] }
    if ($did(setup,19).state == 0) { 
      set %b " $+ $mircdirgraphics\default\ $+ " 
      background -hx %b $+ back3.jpg  
      background -hx %b $+ toolbar.jpg   
      background -lx %b $+ toolbar.jpg  
    }
    if ($did(setup,16).state == 0)  { unset %exstamp1 | unset %exstamp2 | .disable #extended.color  }
  }
  if ($did == 42) { 
    if ($_vr(setup,sound) == off) { _vw setup sound on | sclick | halt }
    else { _vw setup sound off | sclick | halt }
  }
  if ($did == 28) { 
    if ($did(setup,28).state == 1) { _vw setup midi on | sclick }
    else { _vw setup midi off | sclick }
  }
  if ($did == 35) { 
    if ($did(setup,35).state == 1) { _vw modes invisible [on] | mode $me +i | sclick } 
    else { _vw modes invisible [off] | mode $me -i | sclick } 
  }
  if ($did == 36) { 
    if ($did(setup,36).state == 1) { _vw modes wallops [on] | mode $me +w | sclick } 
    else { _vw modes wallops [off] | mode $me -w | sclick } 
  }
  if ($did == 37) { 
    if ($did(setup,37).state == 1) { _vw modes snotice [on] | mode $me +s | sclick } 
    else { _vw modes snotice [off] | mode $me -s | sclick } 
  }
  if ($did == 38) { 
    if ($did(setup,38).state == 1) { set %toolbar [on] | bar } 
    else { set %toolbar [off] | window -c @nexbar | sclick } 
  }
  if ($did == 4) { 
    if ($did(setup,4).sel == 1) { _vw info gender male }
    else _vw info gender female
    genderset
  }
  if ($did == 40) { aj }
  if ($did == 41) { fkey }
  sclick
}
alias extcolor return ( $+ $_vr(color,color_switch) $+ )
